#!/usr/bin/perl -w
use Test;
BEGIN { plan tests => 1 }
BEGIN { unshift @INC, "../blib/lib" } 
use POWER::SSL;

use Socket;
use Fcntl;
use Errno qw( EINPROGRESS EAGAIN );
use Time::HiRes qw( time sleep );

my ($SOCK, $w, $msg, $content, $sslcontent);

{ local *SOCK; $SOCK = *SOCK }
select( (select($SOCK), $|=1)[0] );
socket($SOCK, AF_INET, SOCK_STREAM, getprotobyname('tcp')) or die "socket: $!";
fcntl($SOCK, F_SETFL, O_NONBLOCK) or die "fcntl: $!";
connect($SOCK, sockaddr_in(443, inet_aton('www.google.com'))) or
    ($! != EINPROGRESS and die "connect: $!");
do { vec($w="",fileno($SOCK),1)=1; } unless select(undef,$w,undef,0);
die "connect: $!" if $!=ord getsockopt($SOCK,SOL_SOCKET,SO_ERROR);
$SSL = POWER::SSL->new($SOCK);
$msg = "GET / HTTP/1.0\r\nHost: www.google.com\r\n\r\n";
do {
    my $n = $SSL->sslwrite($msg);
    die "write: $!" if (($! and $! != EAGAIN) and not defined $n);
    $msg = substr($msg, $n) if defined $n;
} while length($msg);
$sslcontent = "";
while ($sslcontent !~ /\r?\n\r?\n/) {
    my $n = $SSL->sslread(my $buf, 100000);
    die "read: $!" if (($! and $! != EAGAIN) and not defined $n);
    $sslcontent .= substr($buf,0,$n) if $n;
    last if $! == 0 and defined($n) and $n == 0;
} 
#print "len=".length($sslcontent)."\n";
#print $sslcontent;
ok($sslcontent, qr/Location:/);

